! Original version by M. Hamabe 1999-09-13 (SPIRAL version2.6)
! Updated by H. Shimizu 2007-09-25 (for Fortran90)
! Updated by M. Hamabe  2007-10-16 (indentation modified)

SUBROUTINE showimg(IW1,IW2,G,TITLE,IFLG,mosaic,nfx,nfy, &
     &   cr_val1,cr_pix1,c_type1,c_delt1, &
     &   cr_val2,cr_pix2,c_type2,c_delt2, &
     &   device,width0,width,ratio,iext,jext,isd,jsd, &
     &   iextd,jextd,gmin0,gmax0,gmin,gmax,ipal,bright,contrast,sign, &
     &   icolor,izm,lastplot,irc)
  
  character*(*) device, TITLE, c_type1, c_type2
  character  ch, XTYPE*12
  integer    PGOPEN
  dimension  G(iext,jext), xi(2), yi(2)
  logical    hardcopy, makegif, graphcopy
  
  hardcopy=.FALSE.
  graphcopy=.FALSE.
  makegif=.FALSE.
  irc=0
  
333 call OPENWIN(IW1,IFLG,device,width,ratio)
  call PGSCF(2)
  !     call INIT(width,ratio)     ! initialize the window size 
222 continue
  IW=1
  if ( hardcopy ) then
     call PGSCF(2)
     if ( iextd*jextd > 1100*1100 ) then
        print *, 'Hardcopy file is too large!'
        hardcopy=.FALSE.
        ipal=ipal_bak
        go to 111
     end if
     if ( icolor == 1 ) then
        IWH=PGOPEN('imgdisp.ps/vcps')
     else
        IWH=PGOPEN('imgdisp.ps/vps')
     end if
     !        call PGSLCT(IWH)
     call PGIDSP(G,IEXT,JEXT,GMIN,GMAX,IPAL,bright,contrast,sign, &
          &      IW,isd,jsd,iextd,jextd)
     call PGTEXT(float(isd),jsd+jextd*1.05,TITLE(:20))
     call PGCLOS(IWH)
     call system('lpr -s imgdisp.ps')
     hardcopy=.FALSE.
     ipal=ipal_bak
  else if ( makegif ) then
     call PGSCF(2)
     IWH=PGOPEN('imgdisp.gif/gif')
     call PGIDSP(G,IEXT,JEXT,GMIN,GMAX,IPAL,bright,contrast,sign, &
          &      IW,isd,jsd,iextd,jextd)
     call PGTEXT(float(isd),jsd+jextd*1.05,TITLE(:20))
     call PGCLOS(IWH)
     makegif=.FALSE.
  else 
     IW=1
     call PGSLCT(IW1)
     call PGIDSP(G,IEXT,JEXT,GMIN,GMAX,IPAL,bright,contrast,sign, &
          &      IW,isd,jsd,iextd,jextd)
     call PGSCH(1.5)
     call PGPTXT(isd+iextd*0.85,jsd+jextd*1.05,0.0,0.0,'[HELP]')
     call PGPTXT(isd+iextd*0.75,jsd+jextd*1.05,0.0,0.0,'[Q]')
     call PGTEXT(float(isd), jsd+jextd*1.05,TITLE(:20))
     call PGSCH(1.0)
  end if
  
111 call PGSLCT(IW1)
  x0=x
  y0=y
  call PGCURS(x,y,ch)                              ! read cursor
  if ( ichar(ch) >= 49 .and. ichar(ch) <= 57 ) then
     read (ch,*) ipal
     call PALETT(ipal,bright,sign*contrast)
  else if ( ch == 'i' ) then
     sign=-sign
     call PALETT(ipal,bright,sign*contrast)
  else if ( ch == 'f' ) then
     bright  =max( 0.0, min(  1.0,abs((x-isd)/iextd) ) )
     contrast=max( 0.0, min( 10.0,abs((y-jsd)/jextd*10.0) ) )
     call PALETT(ipal,bright,sign*contrast)
  else if ( ch=='q' .or. &  ! quit
       &        y > float(jsd+jextd) .and.  &
       &        x > float(isd+iextd)*0.75 .and. &
       &        x < float(isd+iextd)*0.85 ) then 
     irc=1
     return 
  else if ( ch == '?' .or.  &  ! toggle HELP menu
       &        y > float(jsd+jextd) .and.  &
       &        x > float(isd+iextd)*0.85) then
     call HELP
     goto 111
  else if ( ch == '<' ) then ! make the window-size smaller
     width=width*0.8
     call PGSLCT(IW1)
     call PGCLOS(IW1)
     IW1=IFLG
     go to 333
  else if ( ch == '>' ) then ! make the window-size larger
     width=width*1.2
     call PGSLCT(IW1)
     call PGCLOS(IW1)
     IW1=IFLG
     go to 333
  else if ( ch == '/' ) then ! reset the window-size 
     width=width0
     call PGSLCT(IW1)
     call PGCLOS(IW1)
     IW1=IFLG
     go to 333
  else if ( ch == 'r' ) then ! replot
     go to 222
  else if ( ch == 'g' ) then ! make a GIF-file
     makegif=.TRUE.
     call PGPAP (7.0, 1.0)
     go to 222
  else if ( ch == 'p' ) then ! make a hardcopy
     hardcopy=.TRUE.
     icolor=0
     ipal_bak=ipal
     if ( ipal /= 1 .or. ipal /= 2 ) ipal=1
     go to 222
  else if ( ch == 'c' ) then ! make a color-hardcopy
     hardcopy=.TRUE.
     icolor=1
     ipal_bak=ipal
     go to 222
  else if ( ch =='P' ) then ! make a color-hardcopy (profile)
     graphcopy=.TRUE.
     x=x0
     y=y0
     IWH=PGOPEN('imgdisp.ps/ps')
     if ( lastplot == 1 ) then
        if ( c_type1 == 'RA--ARCSEC') then
           XTYPE='RA  (arcsec)'
        else if ( c_type1 == 'ANGSTROM') then
           XTYPE='WAVELENGTH  '
        else if ( c_type1 == 'ARCSEC') then
           XTYPE=' X  (arcsec)'
        else
           XTYPE='    PIXEL   '
        end if
        Umin=cr_val1+(isd-cr_pix1)*c_delt1
        Umax=cr_val1+(isd+iextd-1-cr_pix1)*c_delt1
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'x',iext,jext, &
             &         iextd,jextd,isd,jsd,Umin,Umax,IW2,XTYPE, &
             &         IWH,graphcopy)
     else if ( lastplot == 2 ) then
        if ( c_type2 == 'DEC-ARCSEC') then
           XTYPE='DEC (arcsec)'
        else if ( c_type2 == 'ARCSEC') then
           XTYPE=' X  (arcsec)'
        else
           XTYPE='    PIXEL   '
        end if
        Vmin=cr_val2+(jsd-cr_pix2)*c_delt2
        Vmax=cr_val2+(jsd+jextd-1-cr_pix2)*c_delt2
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'y',iext,jext, &
             &         iextd,jextd,isd,jsd,Vmin,Vmax,IW2,XTYPE,IWH,graphcopy)
     else if ( lastplot == 3 ) then
        if ( index(c_type1,'ARCSEC') /= 0 .and. &
             &           index(c_type2,'ARCSEC') /= 0 ) then
           XTYPE='    ARCSEC  '
        else
           XTYPE='    PIXEL   '
        end if
        Umin2=0.0
        Umax2=sqrt( (xe-x)*(xe-x)+(ye-y)*(ye-y) )
        if ( abs(c_delt1) == abs(c_delt2) ) Umax2=abs(Umax2*c_delt1)
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'l',iext,jext, &
             &    iextd,jextd,isd,jsd,Umin2,Umax2,IW2,XTYPE,IWH,graphcopy)
     end if
     graphcopy=.FALSE.
     go to 111
  else if ( ch == 'z' ) then 
     print '(a,$)', 'z1, z2 = '
     read (*,*) gmin, gmax
     print *, 'z1=',gmin,' z2=',gmax
     call PGERAS
     go to 222
  else if ( y < (jsd-0.5) ) then
     if ( ch=='D' ) then  ! mouse middle button
        gmin=gmin0          ! reset display level
        gmax=gmax0
        bright=0.5
        contrast=1.0
        sign=+1.0
        call PGERAS
        print *, 'z1=',gmin,' z2=',gmax
        go to 222
     else if ( ch == 'A' ) then ! mouse left button
        xx=abs((x-isd)/float(iextd))
        if ( xx < 0.5 ) gmin=gmin-(gmax-gmin)*xx
        if ( xx >= 0.5 ) gmax=gmax-(gmax-gmin)*(1.0-xx)
        if ( gmin >= gmax ) then
           dum=gmax
           gmax=gmin
           gmin=dum
        end if
        call PGERAS
        print *, 'z1=',gmin,' z2=',gmax
        go to 222
     else if ( ch == 'X' ) then ! mouse right button
        xx=abs((x-isd)/float(iextd))
        if ( xx < 0.5 ) gmin=gmin+(gmax-gmin)*xx
        if ( xx >= 0.5 ) gmax=gmax+(gmax-gmin)*(1.0-xx)
        if ( gmin >= gmax ) then
           dum=gmax
           gmax=gmin
           gmin=dum
        end if
        print *, 'z1=',gmin,' z2=',gmax
        call PGERAS
        go to 222
     end if
  else                      ! if ( y>(jsd-0.5) ) -> PLOT mode
     if ( ch == 'x' .or. ch == 'A' ) then ! plot x-profile
        call OPENWIN(IW2,IFLG,device,6.0,0.8)
        if ( c_type1 == 'RA--ARCSEC') then
           XTYPE='RA  (arcsec)'
        else if ( c_type1 == 'ANGSTROM') then
           XTYPE='WAVELENGTH  '
        else if ( c_type1 == 'ARCSEC') then
           XTYPE=' X  (arcsec)'
        else
           XTYPE='    PIXEL   '
        end if
        Umin=cr_val1+(isd-cr_pix1)*c_delt1
        Umax=cr_val1+(isd+iextd-1-cr_pix1)*c_delt1
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'x',iext,jext, &
             &         iextd,jextd,isd,jsd,Umin,Umax,IW2,XTYPE,IWH,graphcopy)
        lastplot=1
        go to 111
     else if ( ch == 'y' .or. ch == 'D' ) then ! plot y-profile
        call OPENWIN(IW2,IFLG,device,6.0,0.8)
        if ( c_type2 == 'DEC-ARCSEC') then
           XTYPE='DEC (arcsec)'
        else if ( c_type2 == 'ARCSEC') then
           XTYPE=' X  (arcsec)'
        else
           XTYPE='    PIXEL   '
        end if
        Vmin=cr_val2+(jsd-cr_pix2)*c_delt2
        Vmax=cr_val2+(jsd+jextd-1-cr_pix2)*c_delt2
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'y',iext,jext, &
             &     iextd,jextd,isd,jsd,Vmin,Vmax,IW2,XTYPE,IWH,graphcopy)
        lastplot=2
        go to 111
     else if ( ch == 'l' ) then ! plot profile alogn a line
        npt=0
        call PGLCUR(2,npt,xi,yi)
        x =xi(1)
        if (  x<1    ) x =1.0
        if (  x>iext ) x =iext
        y =yi(1)
        if (  y<1    ) y =1.0
        if (  y>jext ) y =jext
        xe=xi(2)
        if ( xe<1    ) xe=1.0
        if ( xe>iext ) xe=iext
        ye=yi(2)
        if ( ye<1    ) ye=1.0
        if ( ye>jext ) ye=jext
        call OPENWIN(IW2,IFLG,device,6.0,0.8)
        if ( index(c_type1,'ARCSEC') /= 0 .and. &
             &           index(c_type2,'ARCSEC') /= 0 ) then
           XTYPE='    ARCSEC  '
        else
           XTYPE='    PIXEL   '
        end if
        Umin2=0.0
        Umax2=sqrt( (xe-x)*(xe-x)+(ye-y)*(ye-y) )
        if ( abs(c_delt1) == abs(c_delt2) ) &
             &           Umax2=abs(Umax2*c_delt1)
        call PLOT1D(G,gmin,gmax,x,y,xe,ye,'l',iext,jext, &
             &         iextd,jextd,isd,jsd,Umin2,Umax2,IW2,XTYPE,IWH,graphcopy)
        lastplot=3
        go to 111
     else if ( ch == 'v' ) then ! read pixel value
        ipos=int(x+0.5)
        jpos=int(y+0.5)
        pixval=get_val(g,iext,jext,ipos,jpos)
        iwsx=iext/nfx
        iwsy=jext/nfy
        if ( mosaic == 1 ) then
           iwnx=(ipos/iwsx)+1
           iwny=(jpos/iwsy)+1
           ipos=ipos-iwsx*(iwnx-1)
           jpos=jpos-iwsy*(iwny-1)
           if ( ipos == 0 ) then
              ipos=iwsx
              iwnx=iwnx-1
           end if
           if ( jpos == 0 ) then
              jpos=iwsy
              iwny=iwny-1
           end if
           print '("window=[",i1,",",i1,"]  position=(", &
                &  i5,",",i5,")  value=",f15.5)', &
                &  iwnx,iwny,ipos,jpos,pixval
        else
           print '("position=(",i5,",",i5,")  value=",f15.5)', &
                &  ipos,jpos,pixval
        end if
        Go to 111
     else if ( ch == '0' ) then ! reset zooming factor
        call panzoom(x,y, 0,izm,iext,jext,iextd,jextd,isd,jsd)
     else if ( ch == '+' ) then ! zoom
        call panzoom(x,y, 1,izm,iext,jext,iextd,jextd,isd,jsd)
     else if ( ch == '-' ) then ! unzoom
        call panzoom(x,y,-1,izm,iext,jext,iextd,jextd,isd,jsd)
     else if ( ch == ' ' ) then ! pan
        call panzoom(x,y, 2,izm,iext,jext,iextd,jextd,isd,jsd)
     end if
     go to 222
  end if
  go to 111
  
end SUBROUTINE showimg

!-----------------------------------------------------------------------
SUBROUTINE set_z1z2(G,iext,jext,bitpix,bzero,bscale,gmin0,gmax0,gmin,gmax, &
     & magscale)
  
  character*(*) magscale
  integer       bitpix
  dimension     G(iext,jext)
  
  if ( bitpix == 8 ) then
     gmin0=bzero
     gmax0=bscale*255.0+bzero
     gmin=gmin0
     gmax=gmax0
  else
     call getrng(G,iext,jext,gmin,gmax,magscale)
     gmin0=gmin
     gmax0=gmax
  end if
  
  return
end SUBROUTINE set_z1z2
!-----------------------------------------------------------------------
SUBROUTINE win_defsize(iext,jext,width0,width,ratio)

!     Updated: 1999-09-13 M.Hamabe (change default windows size)

! --- define default window size

  if ( iext >= (jext*1.75) ) then
     width0=8.0
     ratio=float(jext)/float(iext)*1.5
  else if ( iext >= jext .or. jext < (iext*1.2) ) then
     width0=10.0
     ratio=float(jext)/float(iext)*1.1
  else
     hight=12.0
     ratio=float(jext)/float(iext)*1.1
     width0=hight/ratio
  end if
  width=width0
  
  return
end SUBROUTINE win_defsize

!-----------------------------------------------------------------------
SUBROUTINE getrng(G,iext,jext,gmin,gmax,magscale)
  
  character*(*) magscale
  REAL*8    S,SS,T,TT,W
  real*4    G(iext,jext)
  
  hi_sigma=10.0
  if ( magscale == 'yes' ) hi_sigma=100.0
  IS=1
  IE=IEXT
  JS=JEXT/2-30
  JE=jS+60
  GMAX =0.0
  GMIN =0.0
  GMEAN=0.0
  GSD  =0.0
  IF(IS   <   1) IS=1
  IF(IE  > IEXT) IE=IEXT
  IF(JS   <   1) JS=1
  IF(JE  > JEXT) JE=JEXT
  NP=(IE-IS+1)*(JE-JS+1)
  GMAX=-1.0E20
  GMIN=1.0E+20
  S   =0.0D0
  SS  =0.0D0
  
  DO J=JS,JE
     T =0.0D0
     TT=0.0D0
     DO I=IS,IE
        T=T +DBLE(G(I,J))
        TT=TT+DBLE(G(I,J))**2
        IF(G(I,J) >= GMAX) GMAX=G(I,J)
        IF(G(I,J) <= GMIN) GMIN=G(I,J)
     END DO
     S =S +T
     SS=SS+TT
  END DO
  GMEAN=S/DBLE(NP)
  W    =(SS-(S*S)/DBLE(NP))/DBLE(NP-1)
  GSD  =SQRT(W)
  Gmin=Gmean-0.5*GSD
  Gmax=Gmean+hi_sigma*GSD
  
  return
end SUBROUTINE getrng

!-----------------------------------------------------------------------
SUBROUTINE OPENWIN(IW,IFLG,DEVICE,width,ratio)
  
  character*20 DEVICE
  INTEGER  PGOPEN
  
  if ( IW == IFLG ) then    ! if window is not yet opened,
     IW=PGOPEN(DEVICE)
     call PGASK(.FALSE.)    
     ! don't ask "Type <RETURN> for next page: "
     call init(width,ratio)
  end if
  
  return
end SUBROUTINE OPENWIN

!-----------------------------------------------------------------------
SUBROUTINE INIT(width,ratio)
  
  !     Set up graphics device to display image.
  
  call PGPAP(width, ratio)       ! set the size and aspect
  !     call PGPAGE
  call PGSVP(0.0,1.0,0.0,1.0)
  call PGSWIN(0.0,0.5,0.0,1.0)
  !     call PGSCR(0, 0.4, 0.4, 0.4)
  
  RETURN
END SUBROUTINE INIT
!-----------------------------------------------------------------------
SUBROUTINE HELP
  
  print *, ' '
  print *, '-----------------------------------------------------'
  print *, 'Usage of the [key]s and {mouse-button}s'
  print *, ' '
  print *, '          << in the image >>'
  print *, '[r] replot image       [q] quit             [?] help'
  print *, '[<] smaller frame         [>] larger frame    ','[/] normal frame'
  print *, '[z] change display level  [i] reverse color'
  print *, '[f] adjust contrast/brightness'
  print *, '     cursor x position setting brightness [0.0 - 1.0]'
  print *, '     and y position setting contrast [0.0 - 10.0]'
  print *, '[p] hardcopy (image)      [c] color-hardcopy (image)'
  print *, '[P] hardcopy (profile)    [g] make a GIF-file'
  print *, '[1-7] change color palette'
  print *, '[x,A], {left}    x-profile     ','[y,D], {middle}  y-profile'
  print *, '[v] read the position and the value'
  print *, '[+] zoom   [-] unzoom  [0]  reset zoom  [space] pan'
  print *, ' '
  print *, '          << on the color-bar >>'
  print *, '{middle}  reset the display range ','(the values of floor and ceiling)'
  print *, '{left}    decrease the value (floor or ceiling)'
  print *, '{right}   increase the value (floor or ceiling)'
  print *, '        * left  part of the color-bar : floor value'
  print *, '        * right part of the color-bar : ceiling value'
  print *, '-----------------------------------------------------'
  
  return
end SUBROUTINE HELP
!-----------------------------------------------------------------------

SUBROUTINE PGIDSP(G,IEXT,JEXT,GMIN,GMAX,IPAL,bright,contrast,sign,IW, &
     & isd,jsd,iextd,jextd)
  
  REAL G(IEXT,JEXT),GMIN,GMAX,TR(6)
  data tr/0.0,1.0,0.0,0.0,0.0,1.0/
  
  !--------------------------------------------------------------------
  ! PGIMAG
  !--------------------------------------------------------------------
  !     Clear the screen. Set up window and viewport.

  !     call PGPAGE
  if ( IW /= 0 ) call SETVP
  CALL PGERAS
  call PGWNAD(float(isd)-0.5,float(isd+IEXTd)-0.5, &
       &      float(jsd)-0.5,float(jsd+JEXTd)-0.5)
  call PGSCI(1)
  
  !     Set up the color map.
  
  call PALETT(ipal,bright,contrast*sign)
  
  !     Draw the map with PGIMAG.  
  i1=isd
  i2=isd+IEXTd-1
  j1=jsd
  j2=jsd+JEXTd-1
  call PGIMAG(G,IEXT,JEXT,i1,i2,j1,j2,GMIN,GMAX,TR)
  
  call PGSCI(1)
  call PGBOX('bcnts',0.0,0,'bcnts',0.0,1)
  
  !     Draw a wedge.
  
  if ( IW /= 0 ) then
     call PGSCH(0.8)
     call PGWEDG('BI', 3.0, 4.0, GMIN, GMAX, 'Brightness')
     call PGSCH(1.0)
  end if
  
  RETURN
END SUBROUTINE PGIDSP

!-------------------------------------------------------------------
SUBROUTINE PALETT(TYPE,bright,contrast)
  
  !     This routine was taken from pgdemo4.f and modified.
  
  !     Set a "palette" of colors in the range of color indices 
  !     used by PGIMAG.
  
  INTEGER TYPE
  
  REAL NL(2), NR(2), NG(2), NB(2)
  REAL GL(2), GR(2), GG(2), GB(2)
  REAL RL(9), RR(9), RG(9), RB(9)
  REAL HL(5), HR(5), HG(5), HB(5)
  REAL WL(10), WR(10), WG(10), WB(10)
  REAL AL(20), AR(20), AG(20), AB(20)
  REAL TL(4), TR(4), TG(4), TB(4)
  REAL CL(11), CR(11), CG(11), CB(11)
  
  DATA NL /0.0, 1.0/
  DATA NR /1.0, 0.0/
  DATA NG /1.0, 0.0/
  DATA NB /1.0, 0.0/
  
  DATA GL /0.0, 1.0/
  DATA GR /0.0, 1.0/
  DATA GG /0.0, 1.0/
  DATA GB /0.0, 1.0/
  
  DATA RL /-0.5, 0.0, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.7/
  DATA RR / 0.0, 0.0,  0.0,  0.0,  0.6,  1.0,  1.0, 1.0, 1.0/
  DATA RG / 0.0, 0.0,  0.0,  1.0,  1.0,  1.0,  0.6, 0.0, 1.0/
  DATA RB / 0.0, 0.3,  0.8,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0/
  
  DATA HL /0.0, 0.2, 0.4, 0.6, 1.0/
  DATA HR /0.0, 0.5, 1.0, 1.0, 1.0/
  DATA HG /0.0, 0.0, 0.5, 1.0, 1.0/
  DATA HB /0.0, 0.0, 0.0, 0.3, 1.0/
  
  DATA WL /0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0/
  DATA WR /0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0/
  DATA WG /0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0/
  DATA WB /0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0/
  
  DATA AL /0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5, &
       &         0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0/
  DATA AR /0.0, 0.0, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0, &
       &         0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
  DATA AG /0.0, 0.0, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8, &
       &         0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0/
  DATA AB /0.0, 0.0, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9, &
       &         0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
  
  DATA TL /0.0, 0.5, 0.5, 1.0/
  DATA TR /0.2, 0.6, 0.6, 1.0/
  DATA TG /0.0, 0.0, 0.5, 1.0/
  DATA TB /1.0, 0.0, 0.0, 0.0/
  
  DATA CL /0.014, 0.015, 0.135, 0.260, 0.386, 0.505, 0.631, &
       &   0.755, 0.876, 0.970, 1.000/
  DATA CR /0.000, 1.000, 0.990, 0.750, 0.431, 0.137, 0.000, &
       &   0.069, 0.250, 0.470, 0.500/ 
  DATA CG /0.000, 0.157, 0.452, 0.750, 0.902, 0.971, 0.800, &
       &   0.559, 0.250, 0.000, 0.000/
  DATA CB /0.000, 0.314, 0.095, 0.000, 0.095, 0.345, 0.655, &
       &   0.905, 0.9  , 0.950, 1.000/
  
  if ( type < 1 .or. type > 8 ) type=2
  
  IF (TYPE == 1) THEN        !        -- gray scale (negative)
     call PGCTAB(NL, NR, NG, NB, 2, contrast, bright)
  ELSE IF (TYPE == 2) THEN   !        -- gray scale (positive)
     call PGCTAB(GL, GR, GG, GB, 2, contrast, bright)
  ELSE IF (TYPE == 3) THEN   !        -- rainbow
     call PGCTAB(RL, RR, RG, RB, 9, contrast, bright)
  ELSE IF (TYPE == 4) THEN   !        -- heat
     call PGCTAB(HL, HR, HG, HB, 5, contrast, bright)
  ELSE IF (TYPE == 5) THEN   !        -- weird IRAF
     call PGCTAB(WL, WR, WG, WB,10, contrast, bright)
  ELSE IF (TYPE == 6) THEN   !        -- AIPS
     call PGCTAB(AL, AR, AG, AB,20, contrast, bright)
  ELSE IF (TYPE == 7) THEN   !        -- TJP
     call PGCTAB(TL, TR, TG, TB, 4, contrast, bright)
  ELSE IF (TYPE == 8) THEN   !        -- Color
     call PGCTAB(CL, CR, CG, CB, 11, contrast, bright)
  END IF
END SUBROUTINE PALETT

!-------------------------------------------------------------
SUBROUTINE SETVP
!-----------------------------------------------------------------------
! Set the viewport, allowing margins around the edge for annotation.
! (This is similar in effect to PGVSTD, but has different margins.)
! The routine determines the view-surface size and allocates margins
! as fractions of the minimum of width and height.
!-----------------------------------------------------------------------
  REAL D, VPX1, VPX2, VPY1, VPY2
  !
  call PGSVP(0.0, 1.0, 0.0, 1.0)
  call PGQVP(1, VPX1, VPX2, VPY1, VPY2)
  D = MIN(VPX2-VPX1, VPY2-VPY1)/40.0
  VPX1 = VPX1 + 5.0*D
  VPX2 = VPX2 - 2.0*D
  VPY1 = VPY1 + 8.0*D
  VPY2 = VPY2 - 2.0*D
  call PGVSIZ(VPX1, VPX2, VPY1, VPY2)
END SUBROUTINE SETVP
!-----------------------------------------------------------------------
subroutine PLOT1D(G,gmin,gmax,x,y,xe,ye,mode,iext,jext, &
     &     iextd,jextd,isd,jsd,Umin,Umax,IW,XTYPE,IWH,hardcopy)
  
  character :: XTYPE*(*), mode, t_label*80
  real      :: G(iext,jext), xp(20000), yp(20000)
  logical   :: hardcopy
  
  if ( hardcopy ) then
  else
     call PGSLCT(IW)
  end if
  if ( mode == 'x' ) then                ! x-profile
     Udelt=(Umax-Umin)/float(iextd-1)
     call PGENV(Umin,Umax,gmin,gmax,-1,-1)
     if ( index(XTYPE,'PIXEL') /= 0 .or. &
          &        index(XTYPE,'WAVEL') /= 0 ) then
        call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
     else
        call PGBOX('BCNST',60.0,2,'BCNSTV',0.0,-1)
     end if
     do i=1,iextd
        xp(i)=Umin+(i-1)*Udelt
     end do
     jj=int(y+0.5)
     if ( jj < jsd  ) jj=jsd
     if ( jj > jext ) jj=jext
     t_label='X-PLOT (                  '
     write(t_label(9:18),'(''Y='',i5,'')'')') jj
     call PGLABEL(XTYPE,'COUNT',t_label)
     do i=1,iextd
        yp(i)=g(i+isd-1,jj)
     end do
     call PGLINE(iextd,xp,yp)
     xp(1)=Umin+(x-isd)*Udelt
     xp(2)=xp(1)
     yp(1)=gmin
     yp(2)=gmax
     call PGSLS(2)
     call PGLINE(2,xp,yp)
     call PGSLS(1)
  else if ( mode == 'y' ) then           ! y-profile
     Udelt=(Umax-Umin)/float(jextd-1)
     call PGENV(Umin,Umax,gmin,gmax,-1,-1)
     if ( index(XTYPE,'PIXEL') /= 0 ) then
        call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
     else
        call PGBOX('BCNST',60.0,2,'BCNSTV',0.0,-1)
     end if
     do j=1,jextd
        xp(j)=Umin+(j-1)*Udelt
     end do
     ii=int(x+0.5)
     if ( ii < isd  ) ii=isd
     if ( ii > iext ) ii=iext
     t_label='Y-PLOT (                  '
     write(t_label(9:18),'(''X='',i5,'')'')') ii
     call PGLABEL(XTYPE,'COUNT',t_label)
     do j=1,jextd
        yp(j)=g(ii,j+jsd-1)
     end do
     call PGLINE(jextd,xp,yp)
     xp(1)=Umin+(y-jsd)*Udelt
     xp(2)=xp(1)
     yp(1)=gmin
     yp(2)=gmax
     call PGSLS(2)
     call PGLINE(2,xp,yp)
     call PGSLS(1)
  else if ( mode == 'l' ) then           ! profile along the line
     rng=sqrt((x-xe)*(x-xe)+(y-ye)*(y-ye))
     fct=Umax/rng
     npt=int(rng+0.5)+1
     call PGENV(1.0,float(npt)*fct,gmin,gmax,-1,-1)
     if ( index(XTYPE,'PIXEL') /= 0 ) then
        call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
     else
        call PGBOX('BCNST',60.0,2,'BCNSTV',0.0,-1)
     end if
     call PGLABEL(XTYPE,'COUNT','ALONG THE LINE')
     dx=(xe-x)/(npt-1)
     dy=(ye-y)/(npt-1)
     do j=1,npt
        xp(j)=float(j)*fct
     end do
     do j=1,npt
        ii=int(x+(j-1)*dx+0.5)
        jj=int(y+(j-1)*dy+0.5)
        yp(j)=g(ii,jj)
     end do
     call PGLINE(npt,xp,yp)
  end if
  if ( hardcopy ) then
     call PGCLOS(IWH)
     call system('lpr -s imgdisp.ps')
     hardcopy=.FALSE.
  end if
  
  return
end subroutine PLOT1D

!-----------------------------------------------------------------------
function get_val(g,iext,jext,i,j)
  
  dimension g(iext,jext)
  
  get_val=g(i,j)
  
  return
end function get_val

!--------------------------------------------------------------
subroutine panzoom(x,y,mode,izm,iext,jext,iextd,jextd,isd,jsd)
  
  if ( mode == 0 ) then     ! reset zooming factor
     izm=1
     iextd=iext
     jextd=jext
     isd=1
     jsd=1
  else if ( mode == 1 ) then ! zoom
     izm=izm+1
     if ( izm <= 5 ) then
        factor=izm
     else
        factor=10.0*2**(izm-6)
     end if
     iextd=iext/factor
     jextd=jext/factor
     isd=int(x+0.5)-iextd/2
     if ( isd < 1 ) isd=1
     ied=isd+iextd-1
     if ( ied > iext ) ied=iext
     isd=ied-iextd+1
     jsd=int(y+0.5)-jextd/2
     if ( jsd < 1 ) jsd=1
     jed=jsd+jextd-1
     if ( jed > jext ) jed=jext
     jsd=jed-jextd+1
  else if ( mode == -1 ) then ! unzoom
     izm=izm-1
     if (izm < 1 ) then
        izm=1
        iextd=iext
        jextd=jext
        isd=1
        jsd=1
     else
        if ( izm <= 5 ) then
           factor=izm
        else
           factor=10.0*2**(izm-6)
        end if
        iextd=iext/factor
        jextd=jext/factor
        isd=int(x+0.5)-iextd/2
        if ( isd < 1 ) isd=1
        ied=isd+iextd-1
        if ( ied > iext ) ied=iext
        isd=ied-iextd+1
        jsd=int(y+0.5)-jextd/2
        if ( jsd < 1 ) jsd=1
        jed=jsd+jextd-1
        if ( jed > jext ) jed=jext
        jsd=jed-jextd+1
     end if
  else 
     isd=int(x+0.5)-iextd/2
     if ( isd < 1 ) isd=1
     ied=isd+iextd-1
     if ( ied > iext ) ied=iext
     isd=ied-iextd+1
     jsd=int(y+0.5)-jextd/2
     if ( jsd < 1 ) jsd=1
     jed=jsd+jextd-1
     if ( jed > jext ) jed=jext
     jsd=jed-jextd+1
  end if
  
  return
end subroutine panzoom

!------------------------------------------------------------------
subroutine tomag(G,iext,jext,sky,gnull)
  
  dimension G(iext,jext)
  
  do j=1, jext
     do i= 1, iext
        dum=G(i,j)
        if ( dum <= 0.0 ) then
           g(i,j)=gnull
        else
           g(i,j)=-2.5*log10(dum)+sky
        end if
     end do
  end do
  
  return
end subroutine tomag
