!*  <<< SUBPGPLOT >>> -------------- documents are incomplete ---------
!+
!----------------------------------------------------------------------
!======================================================================

!*CURS_IN  -- Read mouse cursor
!+
SUBROUTINE CURS_IN(X,Y,MAX,NDATA)
  integer :: MAX, NDATA
  real    :: X(MAX), Y(MAX)
!
! Arguments:
!--
!
!---------------------------------------------------------------------
  character :: CHR
  
  ndata=0
  print *
  print *, 'Locate cursor and click Middle button'
  print *, '(press "e" for end)'
1 continue
  call PGCURS(xx, yy, chr)
  ic=ichar(chr)
  if ( ic==101 ) goto 999
  if ( ic==68 .or. ic==100 .or. ic==205 .or. ic==237 ) then
     ndata=ndata+1
     x(ndata)=xx
     y(ndata)=yy
     print '('' Read cursor No.'',i2)', ndata
  end if
  goto 1
  
999 return

end SUBROUTINE CURS_IN

!======================================================================

!*SPG_OPN  -- Open a PGPLOT window if it is not opened yet.
!+
SUBROUTINE SPG_OPN(IW,IFLG,DEVICE)
  character*(*) DEVICE
  integer  ::  IW, IFLG
!
! SPG_OPN:
!
! Arguments:
!  IW     (input) : window number
!  IFLAG  (input) : an integer number which means the window is not opened
!  DEVICE (input) : device name ('/XWINDOW','/XSERV',...)
!
!--
!     AUTHOR: 
!     UPDATE: 
! ---------------------------------------------------------------------
  integer :: PGOPEN
  
  if ( IW==IFLG ) then    ! if window is not yet opened,
     IW=PGOPEN(DEVICE)
     call PGASK(.FALSE.)    ! don't ask "Type <return> for next page: "
  end if

  return

end SUBROUTINE SPG_OPN

!======================================================================

!*SPG_DSP  --
!+
SUBROUTINE SPG_DSP(G,IEXT,JEXT,TITLE,GMIN,GMAX,IPAL,IW,ISD,JSD,IEXTD,JEXTD)
  character TITLE*(*)
  real      :: G(IEXT,JEXT), GMIN, GMAX, TR(6)
!
! SPG_DSP:
!
! Arguments:
!  G     (input) :
!
!--
!     author: M.Hamabe
!     update: M.Hamabe    1996-09-22
!-----------------------------------------------------------------------

  DATA   TR/0.0,1.0,0.0,0.0,0.0,1.0/


!     Clear the screen. Set up window and viewport.

!     call PGPAGE
  if ( IW/=0 ) call SPG_SVP
  call PGWNAD(float(isd)-0.5,float(isd+IEXTd)-0.5, &
       &      float(jsd)-0.5,float(jsd+JEXTd)-0.5)
  call PGSCI(1)

!     Set up the color map.

  call SPG_PLT(ipal)

!     Draw the map with PGIMAG. 
  i1=isd
  i2=isd+IEXTd-1
  j1=jsd
  j2=jsd+JEXTd-1
  call PGIMAG(G,IEXT,JEXT,i1,i2,j1,j2,GMIN,GMAX,TR)

  call PGSCI(5)
  call PGBOX('bcnts',0.0,0,'bcnts',0.0,1)

!     Draw a wedge.

  if ( IW/= 0 ) then
     call PGSCH(0.8)
     call PGWEDG('BI', 3.0, 4.0, GMIN, GMAX, 'Brightness')
     call PGSCH(1.0)
  end if
  call PGTEXT(0.0,jext*1.05,TITLE)
  
  return

END SUBROUTINE SPG_DSP

!=======================================================================

!*SPG_PLT  -- set a "palette" of colors 
!+
SUBROUTINE SPG_PLT(TYPE)

  integer :: TYPE
!
! SPG_PLT: Set a "palette" of colors in the range of color indices used 
! by PGIMAG.
!
! Arguments:
!  TYPE  (input) :
!
!--
!
!------------------------------------------------------------------------

  real ::  NL(2), NR(2), NG(2), NB(2)
  real ::  GL(2), GR(2), GG(2), GB(2)
  real ::  RL(9), RR(9), RG(9), RB(9)
  real ::  HL(5), HR(5), HG(5), HB(5)
  real ::  WL(10), WR(10), WG(10), WB(10)
  real ::  AL(20), AR(20), AG(20), AB(20)
  real ::  TL(4), TR(4), TG(4), TB(4)
  real ::  RBL(3), RBR(3), RBG(3), RBB(3)
  
  DATA NL /0.0, 1.0/
  DATA NR /1.0, 0.0/
  DATA NG /1.0, 0.0/
  DATA NB /1.0, 0.0/
  
  DATA GL /0.0, 1.0/
  DATA GR /0.0, 1.0/
  DATA GG /0.0, 1.0/
  DATA GB /0.0, 1.0/
  
  DATA RBL /0.0, 0.5, 1.0/
  DATA RBR /0.0, 0.0, 1.0/
  DATA RBG /0.0, 0.0, 0.0/
  DATA RBB /1.0, 0.0, 0.0/
  
  DATA RL /-0.5, 0.0, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.7/
  DATA RR / 0.0, 0.0,  0.0,  0.0,  0.6,  1.0,  1.0, 1.0, 1.0/
  DATA RG / 0.0, 0.0,  0.0,  1.0,  1.0,  1.0,  0.6, 0.0, 1.0/
  DATA RB / 0.0, 0.3,  0.8,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0/
  
  DATA HL /0.0, 0.2, 0.4, 0.6, 1.0/
  DATA HR /0.0, 0.5, 1.0, 1.0, 1.0/
  DATA HG /0.0, 0.0, 0.5, 1.0, 1.0/
  DATA HB /0.0, 0.0, 0.0, 0.3, 1.0/
  
  DATA WL /0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0/
  DATA WR /0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0/
  DATA WG /0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0/
  DATA WB /0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0/
  
  DATA AL /0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5, &
       &   0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0/
  DATA AR /0.0, 0.0, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0, &
       &   0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
  DATA AG /0.0, 0.0, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8, &
       &   0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0/
  DATA AB /0.0, 0.0, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9, &
       &   0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
  
  DATA TL /0.0, 0.5, 0.5, 1.0/
  DATA TR /0.2, 0.6, 0.6, 1.0/
  DATA TG /0.0, 0.0, 0.5, 1.0/
  DATA TB /1.0, 0.0, 0.0, 0.0/
  
  if ( type<-1 .or. type>6 ) type=1
  
  if ( TYPE==0 ) then        !        -- gray scale (negative)
     call PGCTAB(NL, NR, NG, NB, 2, 1.0, 0.5)
  else if ( TYPE==1 ) then   !        -- gray scale (positive)
     call PGCTAB(GL, GR, GG, GB, 2, 1.0, 0.5)
  else if ( TYPE==2 ) then   !        -- rainbow
     call PGCTAB(RL, RR, RG, RB, 9, 1.0, 0.5)
  else if ( TYPE==3 ) then   !        -- heat
     call PGCTAB(HL, HR, HG, HB, 5, 1.0, 0.5)
  else if ( TYPE==4 ) then   !        -- weird IRAF
     call PGCTAB(WL, WR, WG, WB, 10, 1.0, 0.5)
  else if ( TYPE==5 ) then   !        -- AIPS
     call PGCTAB(AL, AR, AG, AB, 20, 1.0, 0.5)
  else if ( TYPE==6 ) then   !        -- TJP
     call PGCTAB(TL, TR, TG, TB, 4, 1.0, 0.5)
  else if ( TYPE==-1 ) then  !        -- Red & Blue
     call PGCTAB(RBL, RBR, RBG, RBB, 3, 1.0, 0.5)
  end if

  return

END SUBROUTINE SPG_PLT

!========================================================================

!*SPG_SVP  -- set the viewport
!+
SUBROUTINE SPG_SVP

!
! SPG_SVP: set the viewport, allowing margins around the edge for annotation.
! (This is similar in effect to PGVSTD, but has different margins.)
! The routine determines the view-surface size and allocates margins
! as fractions of the minimum of width and height.
!
!-
!
!-----------------------------------------------------------------------
  real ::  D, VPX1, VPX2, VPY1, VPY2

  call PGSVP(0.0, 1.0, 0.0, 1.0)
  call PGQVP(1, VPX1, VPX2, VPY1, VPY2)
  D = MIN(VPX2-VPX1, VPY2-VPY1)/40.0
  VPX1 = VPX1 + 5.0*D
  VPX2 = VPX2 - 2.0*D
  VPY1 = VPY1 + 8.0*D
  VPY2 = VPY2 - 2.0*D
  call PGVSIZ(VPX1, VPX2, VPY1, VPY2)

  return

END SUBROUTINE SPG_SVP

!=======================================================================

!*SPG_BOX  -- draw a box with the current line attributes
!+
SUBROUTINE SPG_BOX(X1,X2,Y1,Y2)
!
! SPG_BOX:
!
! Arguments:
!  X1
!  X2
!  Y1
!  Y2
!--
!
!
!-----------------------------------------------------------------------
  call PGMOVE(x1,y1)
  call PGDRAW(x2,y1)
  call PGDRAW(x2,y2)
  call PGDRAW(x1,y2)
  call PGDRAW(x1,y1)
  
  return

end SUBROUTINE SPG_BOX

!=======================================================================

!*SPG_BOX2 --
!+
SUBROUTINE SPG_BOX2(X1,X2,Y1,Y2,COLOR,LWIDTH,STYLE,LWIDTH_H)
  
  integer :: COLOR, STYLE
!
! SPG_BOX2:
!
! Arguments:
!
!     style:  1 => solid, 2 => outline,  3 => hatched, 4 => cross-hatched
!               (default)
!--
!
!
!----------------------------------------------------------------------

  real :: xpts(4), ypts(4)
  
  xpts(1)=x1
  ypts(1)=y1
  xpts(2)=x2
  ypts(2)=y1
  xpts(3)=x2
  ypts(3)=y2
  xpts(4)=x1
  ypts(4)=y2
  call PGSCI(color)
  if ( style/=2 ) then
     call PGSFS(style)
     call PGSLW(lwidth_h)
     call PGPOLY(4,XPTS,YPTS)
  end if
  call PGSLW(lwidth)
  call PGSFS(2)
  call PGPOLY(4,XPTS,YPTS)
  call PGSLW(1)
  call PGSCI(1)
  
  return

end SUBROUTINE SPG_BOX2

!======================================================================

!*SPG_CIR2 --
!+
SUBROUTINE SPG_CIR2(X,Y,R,COLOR,LWIDTH,STYLE,LWIDTH_H)
  integer :: COLOR, STYLE
!
! SPG_CIR2:
!
! Arguments:
!
!     style:  1 => solid, 2 => outline,  3 => hatched, 4 => cross-hatched
!               (default)
!--
!
!
!----------------------------------------------------------------------
  call PGSCI(color)
  if ( style/=2 ) then
     call PGSLW(lwidth_h)
     call PGSFS(style)
     call PGCIRC(x,y,r)
  end if
  call PGSLW(lwidth)
  call PGSFS(2)
  call PGCIRC(x,y,r)
  call PGSLW(1)
  call PGSCI(1)
  
  return

end SUBROUTINE SPG_CIR2

!========================================================================

!*ZRANGE   -- determine display range
!+
SUBROUTINE ZRANGE(ISC,RMAX,RMIN)
!
! ZRANGE:
!
! Arguments:
!
!--
!     AUTHOR: M.Hamabe
!----------------------------------------------------------------------
 
  if ( ISC==1 ) then
100  continue
     print '(''z1 and z2 ===> '',$)'
     read *, rmin,rmax
     if ( rmin>=rmax ) GOTO 100
  else
200  continue
     print '(''z1 and z2 ( z1 > 0.0 ) ===> '',$)'
     read *, rmin,rmax
     if ( rmin<= 0.0 ) go to 200
     if ( rmax<=rmin ) go to 200
  end if

return

END SUBROUTINE ZRANGE

