!
!       updated by M. Hamabe 1994-08-17 (replace MONGO with PGPLOT)
!       updated by M. Hamabe 1994-09-04 (add eEll parameter)
!       updated by M. Hamabe 2007-10-16 (for Fortran90)
!
!**********************************************************************
SUBROUTINE FIT(u,v,SR,SLOGR,SR4,SMU,FS,FE,bulge, &
     &    KIND,ND,NPR,NDEV,CPARM,CER,eEll)
!	This routine fits the profile to the model of the surface
!	brightness distribution.

  parameter  (MAXPNT=500)
  character  CPARM(2,2)*20, CER(2,2)*15, MODEL
!	character  CDUM2*2
  character  TTL(2,2)*14, yn, eEll*3
  dimension u(MAXPNT,10),v(MAXPNT,10),bulge(10), ndd(10)
  dimension x(MAXPNT), y(MAXPNT),XM(MAXPNT),YM(MAXPNT),yfit(MAXPNT),ND(10)
  dimension FS(3,2), FE(3,2), sgy(MAXPNT), par(4), BACKUP(4)
  dimension SR(MAXPNT), SLOGR(MAXPNT), SR4(MAXPNT), SMU(MAXPNT,3)
  data devc /3.3307127/,expc/1.0857/
  data TTL /'log r\\de\\u =','  \\gm\\de\\u =', &
       &    '  h\\dR\\u =    ','  \\gm\\d0\\u ='/
  
  print *
  print '(''   v : de Vaucouleurs" law '')'
  print '(''   k : Bulge + exponential disk '')'
  print '(''         Select model  <v> = '',$)'
  read '(a1)', model

  if ( model=='k' ) then
     if ( kind==1 .or. kind==4 ) then
        NDEV = 2
        print '(/ ''  bulge fitting range in R = '',$)'
        read *, fS(1,1),fE(1,1)
        call fcalc(fs,fe,1,1)
        print '(/ ''  disk fitting range in R = '',$)'
        read (*,*) fS(1,2),fE(1,2)
        call fcalc(fs,fe,1,2)
!	print '(''   CONFIDENCE LEVEL (90/95/<99>) ='',$)'
!	read '(A2)', CDUM2
!	if ( CDUM==' ' ) then
!	    LVL=99
!	ELSE
!	    read (CDUM2,'(I2)') LVL
!	    if ( LVL<90 .OR. LVL>99 ) LVL=99
!	end if
        LVL = 99
        
        ndat=1
        do  j=1,npr
           NDD(J)=0
           do  i=1,nd(j)
              if ( u(i,j)>=fs(1,1) .and. u(i,j)<=fe(1,2) ) then
                 x(ndat) = u(i,j)
                 y(ndat) = v(i,j)
                 ndd(j)=ndd(j)+1
                 Ndat = Ndat+1
              end if
           end do
        end do
        ndat=nDAT-1
        a=0
        b=0
        CONST =  2.5*devc
        itr=0
        print '(''  Do you have bulge parameter ? '',$)'
        read '(a)', yn
        if ( yn=='Y' .or. yn=='y' ) then
           print '(''   log Re '',$)'
           read *, elogr
           print '(''   eff_mu '',$)'
           read (*,*) eff_mu
           eff_rad = 10**elogr
           D = sqrt(sqrt(eff_rad))
           a = Const / D
           b = eff_mu-CONST
        end if
        BACKUP(1)=999.0
        BACKUP(2)=999.0
        BACKUP(3)=999.0
        BACKUP(4)=999.0
        print *
1000    itr=itr+1
!	disk	fit
        n=1
        do  i=1,ndat
           if ( x(i)>=fS(1,2).and. x(i)<=fE(1,2) ) then
              xm(n) = x(i)
              ym(n) = y(i)
              N = N+1
           end if
        end do
        ndisk = n-1
        call subtra(xm,ym,a,b,ndisk,1)
        call les1(xm,ym,rh,amu0,ndisk,errd,Erh,Emu0)
        h0  = expc/rh

!	bulge	fit
        n=1
        do  i=1,ndat
           if ( x(i)>=fS(1,1).and. x(i)<=fE(1,1) ) then
              xm(n) = sqrt(sqrt(x(i)))
              ym(n) = y(i)
              N = N+1
           end if
        end do
        nbulge = n-1
        call subtra(xm,ym,rh,amu0,nbulge,2)
        call les1(xm,ym,a,b,nbulge,errb,EA,EB)	
!						! least-squares fit
        eff_mu  = CONST + b
        D = CONST / a
        eff_rad = D*D*D*D
        ELOGR 	= LOG10(eff_rad)

!	print '(''+  Itration ='',i3,2X,4F10.3)', itr,elogr,eff_mu,h0,amu0

        Q1 = ABS( elogr  - BACKUP(1) )
        Q2 = ABS( eff_mu - BACKUP(2) )
        Q3 = ABS( h0     - BACKUP(3) )
        Q4 = ABS( amu0   - BACKUP(4) )
        if ( (q1+q2+q3+q4)>3.0E-4 .OR. ITR<=49 ) then
           BACKUP(1) = elogr
           BACKUP(2) = eff_mu
           BACKUP(3) = h0
           BACKUP(4) = amu0
           go to 1000
        end if
        
        print *
        print '(''   BULGE        log Re        ='',f9.3)', elogr
        print '(''         effective brightness ='',f9.3)', eff_mu
        print *
        print '(''   DISK       scale length    ='',f9.3)', h0
        print '(''          central brightness  ='',f9.3)', amu0
        
        print '(/ ''  Simultaneous fitting ( <Y> / N ) '',$)'
        read '(a1)', yn

        sigma = ( errd*ndisk + errb*nbulge ) / float(ndisk+nbulge)
        n=1
        UMIN= 9999.0
        UMAX=-9999.0
        AMUMIN= 9999.0
        AMUMAX=-9999.0
        do  i=1,ndat
!			if ( x(i)>=fS(1,1).and. x(i)<=fE(1,2) ) then
           xm(n) = x(i)
           ym(n) = y(i)
           sgy(n)= sigma
           if ( XM(N)<=UMIN ) UMIN=XM(N)
           if ( XM(N)>=UMAX ) UMAX=XM(N)
           if ( YM(N)<=AMUMIN ) AMUMIN=YM(N)
           if ( YM(N)>=AMUMAX ) AMUMAX=YM(N)
           N = N+1
!		        end if
        end do
        n = n-1
        print '(''    number of data points ='',i3)', n
        CALL SORT(XM,YM,N)
        
        if ( yn/='n' .and. yn/='N' ) then
           par(1)=elogr
           par(2)=eff_mu
           par(3)=h0
           par(4)=amu0
           CALL SIMLFIT(Xm,Ym,par,SGY,yfit,ERR,N)
           elogr=par(1)
           eff_rad=10.0**elogr
           ZZ=SQRT(SQRT(eff_rad))
           A=CONST/ZZ
           eff_mu=par(2)
           B=eff_mu-CONST
           h0=par(3)
           RH=EXPC/h0
           AMU0=par(4)
        else
           do  i=1,n
              SR4(I)   = R
              SR(I)    = R*R*R*R
              SMU(I,1) = A * SR4(I) + B		
              !					! BULGE
              SMU(I,2) = RH * SR(I) + AMU0	
              !					! DISK
              DUM1=10.0**(-SMU(I,1)/2.5)
              DUM2=10.0**(-SMU(I,2)/2.5)
              yfit(I) = -2.5*LOG10(DUM1+DUM2)
           end do
        end if
        
        IFLGD=0
        do  I = 1, MAXPNT
           if ( H0>500. ) then
              R   = 0.1*I
           ELSE
              R   = 0.02*I
           end if
           SR4(I)   = R
           SR(I)    = R*R*R*R
           SLOGR(I) = LOG10(SR(I))
           SMU(I,1) = A * SR4(I) + B		
!							! BULGE
           SMU(I,2) = RH * SR(I) + AMU0	
!							! DISK
           DUM1=10.0**(-SMU(I,1)/2.5)
           DUM2=10.0**(-SMU(I,2)/2.5)
           if ( DUM2>DUM1 ) IFLGD=1
           SMU(I,3) = -2.5*LOG10(DUM1+DUM2)
        end do
        if ( IFLGD==0 ) then
           print *
           print '(''    BULGE IS DOMINAT EVERYWHERE !'')'
        end if
        if ( H0>=1000. ) then
           write (Cparm(1,2),'(A13,F7.0)') TTL(1,2),H0
        ELSE
           write (Cparm(1,2),'(A13,F7.3)') TTL(1,2),H0
        end if
        write (Cparm(2,2),'(A13,F7.3)') TTL(2,2),AMU0

!CCCCC
        if ( eEll=='yes' ) then
!CCCCC
           do  j=1,npr
              print '('' number of data point ='',I3)', ndd(j)
           end do
           print *, 'After this line is for the estimation of the fitting error.'
           print *, 'If you do not know the number of the independent data points,'
           print *, 'please give any number less than total number of the data.'
           print '(/ ''  number of independent points in the profiles = '',$)'
           read *, NIND
           NREJ=N-NIND
           print *, '... Fitting errors are being estimated.'
           print *, '    Please wait for a while.'
           CALL DVCHI2(xm,ym,yfit,n,eff_rad,eff_mu,H0,AMU0,ndisk, &
                &      EX,EY,EMIN,EMAJ,ANG,SG,LVL,NREJ,IFLGD)
           print '( ''0   XC ='',f7.4,''  YC ='',f7.4,''    Remaj ='',f7.4,''  Remin ='',f7.4, &
                &     ''  ang ='',f6.2)', EX,EY,emaj,emin,ang
        end if
     else
        print '('' Please plot profile in linear scale'', / ''   and try again '')'
     end if
  else
     if ( kind==3 .or. kind==6 ) then
        NDEV = 1
        print '(/ ''  fitting range in R**(0.25) = '',$)'
        read *, fS(3,1),fE(3,1)
        call fcalc(fs,fe,3,1)
!		print '(''   CONFIDENCE LEVEL (90/95/<99>) ='',$)'
!		read (*,'(A2)') CDUM2
!		if ( CDUM==' ' ) then
!		    LVL=99
!		ELSE
!		    read (CDUM2,'(I2)') LVL
!		    if ( LVL<90 .OR. LVL>99 ) LVL=99
!		end if
        LVL=99
        n=1
        UMIN= 9999.0
        UMAX=-9999.0
        AMUMIN= 9999.0
        AMUMAX=-9999.0
        do  j=1,npr
           ndd(j)=0
           do  i=1,nd(j)
              if ( u(i,j)>=fS(3,1) .and. u(i,j)<=fE(3,1) ) then
                 xm(n) = u(i,j)
                 ym(n) = v(i,j)
                 ndd(j)=ndd(j)+1
                 if ( XM(N)<=UMIN ) UMIN=XM(N)
                 if ( XM(N)>=UMAX ) UMAX=XM(N)
                 if ( YM(N)<=AMUMIN ) AMUMIN=YM(N)
                 if ( YM(N)>=AMUMAX ) AMUMAX=YM(N)
                 N = N+1
              end if
           end do
        end do
        n = n-1
        call les1(xm,ym,a,b,n,err,EA,EB)	
!							! least-squares fit
        FCTSLP=A*(UMIN+UMAX)
        CONST =  2.5*devc
        eff_mu  = CONST + b
        D = CONST / a
        eff_rad = D*D*D*D
        ELOGR 	= LOG10(eff_rad)
        print '('' log (effective radius)   ='',f7.3)', elogr
        print '(''    effective brightness  ='',f7.3)', eff_mu
        print '(''    number of data points ='',I7)', N
        print '(''    fitting error         ='',f7.4/)', err
!CCCCC
        if ( eEll=='yes' ) then
!CCCCC
           do j=1,npr
              print '('' number of data point ='',I3)', ndd(j)
           end do
           print *, 'After this line is for the estimation of the fitting error.'
           print *, 'If you do not know the number of the independent data points,'
           print *, 'please give any number less than total number of the data.'
           print '(/ ''  number of independent points in the profiles = '',$)'
           read (*,*) NIND
           NREJ=N-NIND
           print *, '... Fitting errors are being estimated.'
           print *, '    Please wait for a while.'
           CALL DVCHI(xm,ym,n, eff_rad, eff_mu,EX,EY,EMIN,EMAJ,ANG,SG,LVL,NREJ)
           print *
           print '(''   Remaj ='',f7.4,''  Remin ='',f7.4,''  ang ='',f6.2)', emaj,emin,ang
        end if

        do  I = 1, MAXPNT
           R   = 0.02*I
           SR4(I)   = R
           SR(I)    = R*R*R*R
           SMU(I,1) = A * SR(I)**0.25 + B
           SLOGR(I) = LOG10(SR(I))
        end do
     else
        print '('' Please plot profile in r**(1/4)-scale'',/ ''   and try again '')'
     end if
  end if
  
  if ( eEll=='yes' ) then
     rngmu=amumax-amumin
     If (rngmu==0.0 ) rngmu=1.0
     eovermu=err/rngmu
     bulge(1)=elogr
     bulge(2)=eff_mu
     bulge(3)=eX
     bulge(4)=eY
     bulge(5)=emin
     bulge(6)=emaj
     bulge(7)=ang
     bulge(8)=rngmu			
!								! mu_range
     bulge(9)=eovermu
     bulge(10)=FCTSLP
     SLOPE=TAN(ANG*3.141593/180.0)
     print *
     print '(''  Fitting range (Umin , Umax) ='',2f10.3)', Umin,Umax
     print '(''  Fitting range (MUmax-MUmin) ='',f10.3, &
          &    ''   error/range ='',f10.4)', rngmu,eovermu
     print '(''           A*(u1+u2), SLOPE ='',2f10.3)', FCTSLP,SLOPE
  end if
  write (Cparm(1,1),'(A13,F7.3)') TTL(1,1),ELOGR
  write (Cparm(2,1),'(A13,F7.3)') TTL(2,1),eff_mu
  write (CER(1,1),'(A1,F6.3,A2,F6.3)') '+',EA2,' -',EA1
  write (CER(2,1),'(7X,A2,F6.3)') '+-',EB
  
  print *
  
  return
END SUBROUTINE FIT
!**********************************************************************
subroutine fcalc(fs,fe,iorg,j)
!
!	This routine changes the scale of the fitting limits FS and FE.
!	iorg=1	: linear --> log & quater-power
!	iorg=2	: not available
!	iorg=3	: quater-power --> linear & log
!
  dimension fs(3,2), fe(3,2)
  
  if ( iorg==1 ) then
     FS(2,j) = LOG10(FS(1,j))
     FE(2,j) = LOG10(FE(1,j))
     FS(3,j) = sqrt(sqrt(FS(1,j)))
     FE(3,j) = sqrt(sqrt(fe(1,j)))
  else if (iorg==3 ) then
     fs4 = fs(3,j)
     fe4 = fe(3,j)
     FS(1,j) = FS4*FS4*FS4*FS4
     FE(1,j) = FE4*FE4*FE4*FE4
     FS(2,j) = LOG10(FS(1,j))
     FE(2,j) = LOG10(FE(1,j))
  end if
  
  return
end subroutine fcalc
!**********************************************************************
SUBROUTINE pltRANG(FS,FE,YMIN,YMAX,KIND1,NDEV)
!
!	This routine plots the ranges of the ordinate used to fit
!	the models to the profile.
!
  dimension FS(3,2), FE(3,2), XP(2), YP(2)
!
!	call setlweight(2)
  FMIN=FS(1,1)
  FMAX=FE(1,1)
  GMIN=FS(1,2)
  GMAX=FE(1,2)
  if ( KIND1==2 .OR. KIND1==5 ) then
     FMIN=FS(2,1)
     FMAX=FE(2,1)
     GMIN=FS(2,2)
     GMAX=FE(2,2)
  ELSE if ( KIND1==3 .OR. KIND1==6 ) then
     FMIN=FS(3,1)
     FMAX=FE(3,1)
     GMIN=FS(3,2)
     GMAX=FE(3,2)
  end if
!	call setexpand(1.)
  call PGSCH(1.0)
  
  XP(1)=FMIN
  XP(2)=FMAX
  YP(1)=YMIN+0.1
  YP(2)=YMIN+0.1
!       call setangle(60.)
!	call points(33.0,1,XP,YP,2)
!       call setangle( 0.)
  call PGPT(2,xp,yp,30)
  XP(1)=FMIN
  XP(2)=FMAX
  YP(1)=YMax-0.1
  YP(2)=YMax-0.1
!	call points(33.0,1,XP,YP,2)
  call PGPT(2,xp,yp,31)
  if ( NDEV>=2 ) then
     XP(1)=GMIN
     XP(2)=GMAX
     YP(1)=YMIN+0.1
     YP(2)=YMIN+0.1
!           call setangle(60.)
!	    call points(33.0,1,XP,YP,2)
!           call setangle( 0.)
     call PGPT(2,xp,yp,30)
     XP(1)=GMIN
     XP(2)=GMAX
     YP(1)=YMax-0.1
     YP(2)=YMax-0.1
!	    call points(33.0,1,XP,YP,2)
     call PGPT(2,xp,yp,31)
  end if

!	call setexpand(1.0)
  
  return
END SUBROUTINE pltRANG
!**********************************************************************
SUBROUTINE DVCHI(R4,MU,N,RE,BE,EX,EY,EMIN,EMAJ,ANG,SG,LVL,NREJ)
!
!	This routine calculates the chi-squres ellipse of the obtained
!	parameter set.

  parameter (MAXPNT=500)
  
  REAL      R4(MAXPNT),MU(MAXPNT),MUFIT(MAXPNT)
  dimension x(MAXPNT),y(MAXPNT),T(92),SIGMAY(MAXPNT)
  
  data pi/3.141593/, devc /3.3307127/
  
  CONST =  2.5*devc
  nfree=n-2
  dum = sqrt(sqrt(re))
  a = const/dum
  b = be-const
  do  I=1,N
     MUFIT(I)= a*r4(i) + b
  end do
  SG=fchisq (MU, sigmay, n, nfree, 0, MUfit)
  do  I=1,N
     SIGMAY(I)=SQRT(SG)
  end do
  CHIMIN=fchisq (MU, sigmay, n, nfree, 1, MUfit)

  print '(/'' chisq at best pt = '',F8.5,''   for'',I5,'' points''/ )',  CHIMIN,N
  BE0=BE
  RE0=LOG10(RE)
  
  CALL CRTCHI(chilim,nfree-NREJ,LVL)
  if ( CHILIM<CHIMIN ) then
     print *, '  crtCHI < minCHI !!!'
     CHILIM=CHIMIN+0.0004
  ELSE
     CALL ANGMESH(T)
     do  I=1,92
        TT =T(I)/180.0*PI
        SN = SIN( TT )
        CS = COS( TT )
        RAD=0.1
        RADL=0.0
        VL=CHIMIN
1000    CONTINUE
        CALL CHIVAL(MU,R4,SIGMAY,RAD,SN,CS,BE0,RE0,N,NFREE,CHI2)
        if ( CHI2<CHILIM ) then
           RAD=RAD*2.0	
           GO TO 1000
        end if
        RADH=RAD
        VH=CHI2
        
2000    RAD=(RADH+RADL)*0.5
        CALL CHIVAL(MU,R4,SIGMAY,RAD,SN,CS,BE0,RE0,N,NFREE,CHI2)
        if ( ABS(VH-VL)<0.002 ) then		
!						! 0.001
           GO TO 30
        ELSE
           if ( CHI2>CHILIM ) then
              RADH=RAD
              VH=CHI2
              GO TO 2000
           ELSE
              RADL=RAD
              VL=CHI2
              GO TO 2000
           end if
        end if
        
30      RR = RAD
        x(i)=rr*CS
        y(i)=rr*SN
!	    print '(''+'',4X,''Ending Ray'',I3)', I
        open (99,file='ChiEll.dat')
        write(99,'(1X,4F10.6,I5)') X(I),Y(I),CHI2,RAD,I
     end do
     
     CALL FITELL (X,Y,EX,EY,92,0,EMAJ,EMIN,ANG,SIGM,IERR)
     ANG  = 90.0-ANG
  end if

  return
END SUBROUTINE DVCHI
!************************************
SUBROUTINE CHIVAL(MU,R4,SIGMAY,DELTA,SN,CS,BE0,RE0,N,NFREE,CHI2)
  
  parameter (MAXPNT=500)
  REAL      R4(MAXPNT),MU(MAXPNT), MUFIT(MAXPNT),SIGMAY(MAXPNT)
  data      devc /3.3307127/
  CONST =  2.5*devc
        
  DELTB=DELTA*SN
  DELTR=DELTA*CS
  BE=BE0+DELTB
  RE=RE0+DELTR
  RE=10.**RE
  CHI2=0.
  dum = sqrt(sqrt(re))
  a = const/dum
  b = be-const
  do  I=1,N
     MUFIT(I)= a*r4(I) + b
  end do
  CHI2=fchisq (MU, sigmay, n, nfree, 1, MUfit)
  
  return
END SUBROUTINE CHIVAL
!**********************************************************************
SUBROUTINE DVCHI2 (R,MU,mufit,N,RE,BE,H0,AMU0,ndisk,EX,EY,EMIN,EMAJ,ANG,SG,LVL,NREJ,IFLG)
!
!	This routine calculates the chi-squres ellipse of the obtained
!	parameter set.

  parameter (MAXPNT=500)
  
  REAL      R(MAXPNT),MU(MAXPNT),MUFIT(MAXPNT)
  dimension x(MAXPNT),y(MAXPNT),SIGMAY(MAXPNT),T(92)
  DATA pi/3.141593/
  
  n0=n
  nfree=n-4
  SG=fchisq (MU, sigmay, n, nfree, 0, MUfit)
  do  I=1,N
     SIGMAY(I)=SQRT(SG)
  end do
  CHIMIN=fchisq (MU, sigmay, n, nfree, 1, MUfit)
  
  print '(/'' chisq at best pt = '',F8.5,''   for'',I5,'' points''/ )',  CHIMIN,N
  BE0=BE
  RE0=LOG10(RE)
  
  CALL CRTCHI(chilim,nfree-NREJ,LVL)
  CALL ANGMESH(T)
  
555 CONTINUE
  if ( NERR>5 ) IFLG=0
  NERR=0
  
  do  I=1,92
     TT =T(I)/180.0*PI
     SN = SIN( TT )
     CS = COS( TT )
     RAD=0.01
777  RADL=0.0
     VL=CHIMIN
1000 CONTINUE
     n=n0
     CALL CHIVAL2(MU,R,SIGMAY,RAD,SN,CS,BE0,RE0,H0,AMU0,N,ndisk,CHI2,IFLG)
     if ( CHI2<CHILIM ) then
        RAD=RAD*2.0
        GO TO 1000
     end if
     RADH=RAD
     VH=CHI2
     IT=0
2000 RAD=(RADH+RADL)*0.5
     if ( (VH-CHILIM)*(VL-CHILIM)>0. ) GO TO 777
     N=N0
     CALL CHIVAL2(MU,R,SIGMAY,RAD,SN,CS,BE0,RE0,H0,AMU0,N,ndisk,CHI2,IFLG)
     IT=IT+1
     if ( (CHI2/=999.0 .and. ABS(VH-VL)<0.001) .OR. IT>149 ) then
        GO TO 3000
     ELSE if ( RAD<=0.00001 ) then
        NERR=NERR+1
        if ( NERR>10 ) GO TO 555
        GO TO 3000
     ELSE
        if ( CHI2>CHILIM ) then
           RADH=RAD
           VH=CHI2
           GO TO 2000
        ELSE
           RADL=RAD
           VL=CHI2
           GO TO 2000
        end if
     end if
     
3000 CONTINUE
     X(I)=RAD*CS
     Y(I)=RAD*SN
     write(99,'(1X,4F10.6,2I5)') X(I),Y(I),CHI2,RAD,I,IT
!	    print '(''+'',4X,''Ending Ray'',I3,''   IT='',I3)', I,IT
  end do
  CALL FITELL (X,Y,EX,EY,92,0,EMAJ,EMIN,ANG,SIGM,IERR)
  ANG  = 90.0-ANG
  N=N0
  
  return
END SUBROUTINE DVCHI2
!************************************
SUBROUTINE CHIVAL2(MU,R,SIGMAY,DELTA,SN,CS,BE0,RE0,H0,AMU0,N0,ndisk,CHI2,IFLG)
  
  parameter (MAXPNT=500)
  REAL      R(MAXPNT),MU(MAXPNT),yFIT(MAXPNT),SIGMAY(MAXPNT)
  REAL      x(MAXPNT),y(MAXPNT)
  data  devc /3.3307127/, expc/1.0857/
  CONST =  2.5*devc
  
  N=N0
  DP1=H0
  DP2=AMU0
  
  DELTB=DELTA*SN
  DELTR=DELTA*CS
  BE=BE0+DELTB
  RE=RE0+DELTR
  RE=10.**RE
  
  CHI2=0.
  dum = sqrt(sqrt(re))
  a = const/dum
  b = be-const
  
  if ( IFLG==0 ) GO TO 1
  do  i=1,n
     x(i) = r(i)
     y(i) = mu(i)
  end do
  call subtra(x,y,a,b,n,1)
  
  k=0
  do  i=1,n-1
     if ( y(i)<y(i+1) ) then
        k=k+1
     end if
  end do
  ndd = k-2
  ndd	= min(ndisk-2,ndd)
  nomit = n-ndd
  if ( ndd>4 ) then
     IDSK=1
     k=1
     do  i=1,n
        if ( i>nomit ) then
           x(k)=x(i)
           y(k)=y(i)
           k=k+1
        end if
     end do
     nles=k-1		
     call les1  (x,y,RH,AMU0,nles,err,EA,EB)
     H0=EXPC/RH
  else
     IDSK=0
  end if
  
1 CONTINUE
  do  i=1,n0
     if ( iflg==0 ) then
        rh=expc/dp1
        DISK=RH*R(i)+dp2
        DISK=10.0**(-DISK/2.5)
     else if ( IDSK==1 .and. h0>0 ) then
        DISK=RH*R(i)+AMU0
        DISK=10.0**(-DISK/2.5)
     else
        DISK=0.0
     end if
     BULGE=A*R(I)**0.25+B
     BULGE=10.0**(-BULGE/2.5)
     YFIT(I)= -2.5*LOG10(DISK+BULGE)
  end do
  NFREE=N0-4
  CHI2=fchisq (MU, sigmay, n0, nfree, 1, yfit)
  H0  =DP1
  AMU0=DP2
  
  return
END SUBROUTINE CHIVAL2
!***********************************************************
SUBROUTINE SIMLFIT(X,Y,A,SGY,yfit,ERR,NPTS)

  parameter (MAXPNT=500)
  dimension X(MAXPNT),Y(MAXPNT),sgY(MAXPNT),A(4),dA(4)
  dimension sgA(4),yfit(MAXPNT),abak(4)
  
  NTERMS = 4
  MODE = 1
  FLAMDA=0.001
  do  i=1,4
     abak(i)=a(i)
  end do
  it = 0
1 continue
  da(1)=0.1
  da(2)=1.0
  da(3)=a(3)/10.0
  da(4)=1.0
  
  CALL CURFIT (x,y,sgy,npts,nterms,mode,a,da,sga,flamda,yfit,chisqr)
  it=it+1
  if ( IT==1 .OR. MOD(IT,10)==0 ) then
     print '('' it ='',i3,''   parm ='',4f10.4,6X,''x2 ='',f10.6)', &
          & it,a(1), a(2), a(3), a(4), chisqr
  end if
  crtmax=0.0
  do  i=1,4
     crt=abs( a(i)-abak(i) )
     crtmax=max(crtmax,crt)
     abak(i)=a(i)
  end do
  if ( crtmax>1.0e-4 ) go to 1
  if ( mod(it,10)/=0 ) &
       & print '('' it ='',i3,''   parm ='',4f10.4,6X,''x2 ='',f10.6)', &
       & it,a(1), a(2), a(3), a(4), chisqr
  
  sum=0.0D0
  do  i=1,npts
     dum = y(i)-yfit(i)
     sum = sum + dum*dum
  end do
  wt=npts-4
  if ( wt<1.0 ) wt=1.0D0
  VAR = sum/wt
  err = sqrt(VAR)
  print '(''   fitting error ='',f10.4)', err
  
  return

END SUBROUTINE SIMLFIT

!***********************************************************
subroutine fderiv (x, i, a, da, nterms, deriv)
  dimension x(1), a(4), da(1), deriv(1)
  
  do  j=1, nterms
     aj = a(j)
     h = da(j)
     a(j) = aj+h
     yfit = galaxy (x, i, a)
     a(j) = aj-h
     deriv(j) = (yfit-galaxy(x,i,a)) / (2.0*h)
     a(j) = aj
  end do
  
  return
end subroutine fderiv
!***********************************************************
function galaxy(r,i,p)
!		p(1) = logRe,  p(2) = MUe,
!		p(3) = Rd,  p(4) = MU(o)d

  dimension r(1), p(4)
  data  C /3.3307127/
!
  ri = r(i)
  RE=10.0**P(1)
  r41 = sqrt(sqrt( ri/re )) - 1.0
  AINT0 = -C*R41
  AINT0 = AINT0 - P(2)/2.5
  bulge = 10.0**AINT0
  AI0   = 10.0**(-P(4)/2.5)
  DISK  = AI0*EXP(-RI/ P(3) )
  galaxy = -2.5*log10( bulge+disk )
  
  return
end function galaxy
!***********************************************************
function fchisq (y, sgy, npts, nfree, mode, yfit)
!
!	evaluate reduced chi square for fit to data
!		fchisq = Sum{ (y-yfit)**2/sg**2) } / nfree
!	parameters
!		y	: data points
!		sgy	: standard deviation for data points
!		npts	: number of data points
!		nfree	: number of degree of freedom
!		mode	: dtermines method of weighting least-squares fit
!			  +1 (instrumental) weight(i) = 1.0/sgy(i)**2
!			   0 (no weighting) weight(i) = 1.0
!			  -1 (statistical ) weight(i) = 1.0/y(i)
!		yfit	: calculated values of y

  parameter (MAXPNT=500)
  real*8	  chisq, weight(MAXPNT)
  dimension y(1), sgy(1), yfit(1)
  
  chisq = 0.0
  if ( nfree>0 ) then
     call wgtcal (weight,y,sgy,npts,mode)
     do  i=1, npts
        chisq = chisq + weight(i)*(y(i)-yfit(i))**2
     end do
     
     free = nfree
     fchisq = chisq/free
  else
     fchisq = 0.0
  end if
  
  return
end function fchisq
!**********************************************************************
subroutine subtra(x,y,slope,cut,n,model)
!
!	This routine subtarct the luminosity of a component from the
!	total luminosity profile.

  parameter (MAXPNT=500)
  
  dimension x(MAXPNT), y(MAXPNT), YY(MAXPNT)
  
  if ( model==1 ) then			
!						! total - bulge
     if ( slope==0.0 .and. cut==0.0 ) return
     do  i=1,n
        xx	=sqrt(sqrt(x(i)))
        tot	=10.0**(-y(i)/2.5)
        bulgem	=slope*xx+cut
        bulge	=10.0**(-bulgem/2.5)
        yY(i)	=tot-bulge
     end do
  else if ( model==2 ) then		
!						! total - disk
     do  i=1,n
        xx	=x(i)*x(i)*x(i)*x(i)
        tot	=10.0**(-y(i)/2.5)
        diskm	=slope*xx+cut
        disk	=10.0**(-diskm/2.5)
        yY(i)	=tot-disk
     end do
  end if
  NN=1
  do  I=1,N
     if ( YY(I)>0.0 ) then
        X(NN)=X(I)
        Y(NN)=-2.5*LOG10(YY(I))
        NN=NN+1
     end if
  end do
  N=NN-1
  
  return
end subroutine subtra
!**********************************************************************
SUBROUTINE CRTCHI(CHILIM,N,L)
  
  parameter (MAXPNT=500)
  
  dimension CRT68(50),  CRT90(50),  CRT95(50),  CRT99(50)
  dimension DRT68(13,2),DRT90(13,2),DRT95(13,2),DRT99(13,2)
  dimension X(MAXPNT), Y(MAXPNT)
  
  DATA CRT99 /		&
!				! chi-squares for 99% confidence level
       &  6.635,4.605,3.780,3.319,3.017,2.802,2.639,2.511,2.407,2.321, &
       &  2.248,2.185,2.130,2.082,2.039,2.000,1.965,1.934,1.905,1.878, &
       &  1.854,1.831,1.810,1.791,1.772,1.755,1.739,1.724,1.710,1.696, &
       &  1.684,1.671,1.660,1.649,1.638,1.628,1.619,1.610,1.601,1.592, &
       &  1.584,1.576,1.569,1.562,1.555,1.548,1.541,1.535,1.529,1.523/ 
  DATA DRT99 /   30.,  40.,  50., 60.,  70.,  80.,  90., 100., 120., 140., 160., 180., 200., &
       &  1.696,1.592,1.523,1.473,1.435,1.404,1.379,1.358,1.325,1.299,1.278,1.261,1.247/

  DATA CRT95 / &
!				! chi-squares for 95% confidence level
       &  3.841,2.996,2.605,2.372,2.214,2.099,2.010,1.938,1.880,1.831,&
       &  1.789,1.752,1.720,1.692,1.666,1.644,1.623,1.604,1.586,1.571,&
       &  1.556,1.542,1.529,1.517,1.506,1.496,1.486,1.476,1.468,1.459,&
       &  1.451,1.444,1.436,1.429,1.423,1.417,1.411,1.405,1.399,1.394,&
       &  1.389,1.384,1.379,1.375,1.370,1.366,1.362,1.358,1.354,1.350/
  DATA DRT95 / 30.,  40.,  50., 60.,  70.,  80.,  90., 100., 120., 140., 160., 180., 200.,&
       & 1.459,1.394,1.350,1.318,1.293,1.273,1.257,1.243,1.221,1.204,1.191,1.179,1.170/
  
  data crt90/&
!				! chi-squares for 90% confidence level
       &  2.706,2.303,2.084,1.945,1.847,1.774,1.717,1.670,1.632,1.599, &
       &  1.570,1.546,1.524,1.505,1.487,1.471,1.457,1.444,1.432,1.421, &
       &  1.410,1.401,1.392,1.383,1.375,1.368,1.361,1.354,1.348,1.342, &
       &  1.336,1.331,1.326,1.321,1.316,1.311,1.307,1.303,1.299,1.295, &
       &  1.291,1.288,1.284,1.281,1.278,1.275,1.272,1.269,1.266,1.263/
  DATA DRT90 / 30.,  40.,  50., 60.,  70.,  80.,  90., 100., 120., 140., 160., 180., 200., &
       &  1.342,1.295,1.263,1.240,1.222,1.207,1.195,1.185,1.169,1.156,1.146,1.137,1.130/
  
  data crt68/ &
!				! chi-squares for 68.26% confidence level
       &  0.9996,1.1476,1.1754,1.1797,1.1773,1.1729,1.1679,1.1628,1.1580, &
       &  1.1535,1.1492,1.1453,1.1416,1.1382,1.1350,1.1320,1.1292,1.1265, &
       &  1.1241,1.1217,1.1195,1.1174,1.1155,1.1136,1.1118,1.1101,1.1084, &
       &  1.1069,1.1054,1.1040,1.1025,1.1013,1.1002,1.0988,1.0976,1.0965, &
       &  1.0954,1.0943,1.0933,1.0923,1.0914,1.0905,1.0896,1.0887,1.0878, &
       &  1.0870,1.0862,1.0855,1.0847,1.0840/
  DATA DRT68 /   30.,  40.,  50., 60.,  70.,  80.,  90., 100., 120., 140., 160., 180., 200.,&
       &  1.1040,1.0923,1.0840,1.0776,1.0725,1.0683,1.0648,1.0618,1.0568,1.0529,1.0498,1.048,1.047/

  if ( N<=50 ) then
     if ( L==68 ) 	CHILIM=CRT68(N)
     if ( L==90 ) 	CHILIM=CRT90(N)
     if ( L==95 ) 	CHILIM=CRT95(N)
     if ( L==99 ) 	CHILIM=CRT99(N)
  ELSE
     do  I=1,13
        if ( L==68 ) X(I)=DRT68(I,1)
        if ( L==68 ) Y(I)=DRT68(I,2)
        if ( L==90 ) X(I)=DRT90(I,1)
        if ( L==90 ) Y(I)=DRT90(I,2)
        if ( L==95 ) X(I)=DRT95(I,1)
        if ( L==95 ) Y(I)=DRT95(I,2)
        if ( L==99 ) X(I)=DRT99(I,1)
        if ( L==99 ) Y(I)=DRT99(I,2)
     end do
     FREE=FLOAT(N)
     CALL INTERP(X,Y,13,4,FREE,CHILIM)
  end if
  print '('' limit chi-squared value ='', &
       &      F6.3,'' ('',I3,'')  at '',I2,''% level'' / )', CHILIM, N,L
  
  return
END SUBROUTINE CRTCHI
!**********************************************************************
SUBROUTINE ANGMESH(T)
  dimension T(92),ANG(92)
  DATA ANG/&
       &   40. , 60. , 65. , 66. , 67. , 68. , 69. , 70. , 70.5, 71. ,&
       &   71.5, 72. , 72.5, 73. , 73.5, 74. , 74.5, 75. , 75.5, 76. ,&
       &   76.5, 77. , 77.5, 78. , 78.5, 79. , 79.5, 80. , 80.5, 81. ,&
       &   81.5, 82. , 82.5, 83. , 83.5, 84. , 84.5, 85. , 86. , 87. ,&
       &   88. , 89. , 90. ,100. ,120. ,170. ,220. ,240. ,245. ,246. ,&
       &  247. ,248. ,249. ,250. ,250.5,251. ,251.5,252. ,252.5,253. ,&
       &  253.5,254. ,254.5,255. ,255.5,256. ,256.5,257. ,257.5,258. ,&
       &  258.5,259. ,259.5,260. ,260.5,261. ,261.5,262. ,262.5,263. ,&
       &  263.5,264. ,264.5,265. ,266. ,267. ,268. ,269. ,270. ,280. ,&
       &  300. ,350. /
  
  do  I=1,92
     T(I)=ANG(I)
  end do
  
  return

END SUBROUTINE ANGMESH

!*********************************************************	
SUBROUTINE SORT (X,Y,N)
  
  parameter (MAXPNT=500)
  character FLG(MAXPNT)
  dimension X(MAXPNT),Y(MAXPNT),XD(MAXPNT),YD(MAXPNT),ID(MAXPNT)
  
  do  I=1,N
     FLG(I) = '0'
     XD(I)=X(I)
     YD(I)=Y(I)
  end do
  
  do J=1,N
     IMIN=1
     XMIN=999.0
     do I=1,N
        if ( X(I)<=XMIN .and. FLG(I)=='0'  ) then
           XMIN=X(I)
           IMIN=I
        end if
     end do
     ID(J)=IMIN
     FLG(IMIN)='1'
  end do
  
  do  I=1,N
     X(I)=XD(ID(I))
     Y(I)=YD(ID(I))
  end do
  
  return

END SUBROUTINE SORT
